#include <GL/gl.h>
#include <assert.h>
#include "display_list.hpp"

namespace oiran { namespace linda {


	display_list_t::display_list_t() :
			M_id(0)
	{
	}

	display_list_t::~display_list_t()
	{
		if(M_id)
			glDeleteLists(M_id, 1);
	}

	void
	display_list_t::begin()
	{
		assert(M_id == 0 && "display list is already created.");

		M_id = glGenLists(1);
		glNewList(M_id, GL_COMPILE);
	}

	void
	display_list_t::end()
	{
		assert(M_id != 0 && "display list is not created yet.");
		glEndList();
	}

	void
	display_list_t::call()
	{
		glCallList(M_id);
	}


}} // namespace oiran::linda.
