#ifndef FIELD_HPP
#define FIELD_HPP

#include <oiran/linda/graphics.hpp>
#include "defs.hpp"


class mino_t;


class field_t
{
public:
	enum {
		wait,
		line_clear
	};

	static const int line_clear_delay;

	field_t();

	void init(mino_t* mino);
	void update();
	void draw(oiran::linda::graphics_t& g);

	bool collision_detection(int x, int y, const int* mino);
	void lock(int x, int y, const int* mino);

	int score() const	{ return M_score; }

private:
	void _check_lines();
	void _clear_lines();

private:
	mino_t* M_mino;

	int M_state;
	int M_state_count;

	int M_blocks[field_width * field_height];
	int M_score;
};


#endif // FIELD_HPP
